



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ON、WHERE、HAVING的区别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ON、WHERE、HAVING的区别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-22 00:31:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>ON 、WHERE、HAVING都能通过限制条件筛选数据，但他们的使用及其不同。下面我们来分析三者之间的区别。</p>
<h3>1.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ON 和WHERE</h3>
<p>所有的查询都回产生一个中间临时报表，查询结果就是从返回临时报表中得到。ON和WHERE后面所跟限制条件的区别，主要与限制条件起作用的时机有关，ON根据限制条件对数据库记录进行过滤，然后生产临时表；而WHERE是在临时表生产之后，根据限制条件从临时表中筛选结果。</p>
<p>因为以上原因，ON和WHERE的区别主要有下：</p>
<blockquote><p>1）&nbsp; 返回结果：在左外（右外）连接中，ON会返回左表（右表）中的所有记录；而WHERE中，此时相当于inner join，只会返回满足条件的记录（因为是从临时表中筛选，会过滤掉不满足条件的）。</p>
<p>2）&nbsp; 速度：因为ON限制条件发生时间较早，临时表的数据集要小，因此ON的性能要优于WHERE。</p></blockquote>
<h3>2.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; HAVING和WHERE</h3>
<p>HAVING和WHERE的区别也是与限制条件起作用时机有关，HAVING是在聚集函数计算结果出来之后筛选结果，查询结果只返回符合条件的分组，HAVING不能单独出现，只能出现在GROUP BY子句中。；而WHERE是在计算之前筛选结果，如果聚集函数使用WHERE，那么聚集函数只计算满足WHERE子句限制条件的数据,例如：</p>
<div>
<ol><li>SELECT&nbsp;COUNT(id)&nbsp;FROM&nbsp;db_equip&nbsp;WHERE&nbsp;tb_equip_type&nbsp;=&nbsp;&lsquo;2&rsquo;;</li></ol>
</div>
<p>Count计算的结果是首先筛选设备类型为2的的设备，然后统计设备类型为2类型的数量。</p>
<p>在使用和功能上，HAVING和WHERE有以下区别：</p>
<blockquote><p>1）&nbsp;&nbsp;HAVING不能单独出现，只能出现在GROUP BY子句之中；WHERE即可以和SELECT等其他子句搭配使用，也可以和GROUP BY子句搭配使用，WHERE的优先级要高于聚合函数高于HAVING。</p>
<p>2）&nbsp; 因为WHERE在聚集函数之前筛选数据，HAVING在计算之后筛选分组，因此WHERE的查询速度要比HAVING的查询速度快。</p></blockquote>
<h3>3.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 总结</h3>
<p>ON、WHERE、HAVING的主要差别是其子句中限制条件起作用时机引起的，ON是在生产临时表之前根据条件筛选记录，WHERE是从生产的临时表中筛选数据，而HAVING是对临时表中满足条件的数据，进行计算分组之后，通过HAVING限制语句筛选分组，返回结果是满足HAVING子句限制的分组。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pk178x.html">Android开发学习&mdash;&mdash; shape标签的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jd0el9.html">Netty学习四&colon;Channel</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxjpoj9.html">【POJ】1284 Primitive Roots</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxv72j9.html">eclipse-java&sol;spring mvc常见错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/49go6g7q.html">学习C语言的数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j00weeq.html">php 采集类snoopy http&colon;&sol;&sol;www&period;jb51&period;net&sol;article&sol;27568&period;htm &vert; cURL、file&lowbar;get&lowbar;contents、snoopy&period;class&period;php 优缺点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmxnwx9.html">fstat - 读取文件相关信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdgvky8.html">iOS 写入文件保存数据的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmr6v19.html">explicit 关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0oylwq.html">python笔记&mdash;&mdash;第二天</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp5zyzq.html">servlet第2讲&lpar;上集&rpar;----创建servlet实例（实现servlet接口）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m1dj38.html">Chromium与CEF的多进程模型及相关參数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy135dgq.html">Goland 提示 ：configuration is still incorrect 的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gg5m6q.html">SSM&plus;Netty项目结合思路</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gd7mvq.html">Flask项目示例目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv23re19.html">jq获取图片并转换为base64</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wrjdzq.html">AM335x启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveepxz9.html">e742&period; 加入标签的可拖动能力</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn5okxq.html">Kindle一周使用感受</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zknx4n8.html">uvalive 7299 Boggle</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7m72zeq.html">java重构、重载、重写</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd463e8.html">MongoDB &lpar;三&rpar; MongoDB 安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e10rox9.html">Hadoop处理大量小文件的问题和解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmopyx9.html">怎么修改mysql密码</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1vemd9.html">eclipse调试web项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1md079.html">java消息队列</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mndvk6q.html">swift：入门知识之协议与扩展</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm36209.html">Android处理Bitmap的一些方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1m6369.html">node io&period;sockt 聊天应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m7ylxq.html">js 去空格函数与正则</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
